# coding: utf-8

"""
    Nuon

    API for managing nuon apps, components, and installs.

    The version of the OpenAPI document: 0.19.66
    Contact: support@nuon.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json




from pydantic import BaseModel, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from nuon.models.app_install import AppInstall
from nuon.models.service_rendered_installer import ServiceRenderedInstaller
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ServiceRenderedInstall(BaseModel):
    """
    ServiceRenderedInstall
    """ # noqa: E501
    install: Optional[AppInstall] = None
    installer: Optional[ServiceRenderedInstaller] = None
    installer_content: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["install", "installer", "installer_content"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ServiceRenderedInstall from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of install
        if self.install:
            _dict['install'] = self.install.to_dict()
        # override the default output from pydantic by calling `to_dict()` of installer
        if self.installer:
            _dict['installer'] = self.installer.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ServiceRenderedInstall from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "install": AppInstall.from_dict(obj.get("install")) if obj.get("install") is not None else None,
            "installer": ServiceRenderedInstaller.from_dict(obj.get("installer")) if obj.get("installer") is not None else None,
            "installer_content": obj.get("installer_content")
        })
        return _obj


